#include "stdafx.h"

#include <jenga/include/smoothie/Smoothie.h>
#include <jenga/include/smoothie/LexicalAnalysis.h>

#include <Compiler.h>

#include "../BasicCompiler_Common/common.h"
#include "Opcode.h"

void PushReturnValue(int type){
	//֐̖߂lX^bNփvbV
	//̏ł́AesiAedi͎gps

	if(type==DEF_OBJECT || type==DEF_STRUCT){
		//push eax
		compiler.codeGenerator.op_push(REG_EAX);
	}
	else if(type==DEF_DOUBLE){
		//sub esp,8
		compiler.codeGenerator.op_sub_esp(8);

		//fstp qword ptr[esp]
		compiler.codeGenerator.op_fstp_basereg( DEF_DOUBLE, REG_ESP );
	}
	else if(type==DEF_SINGLE){
		//sub esp,4
		compiler.codeGenerator.op_sub_esp(4);

		//fstp dword ptr[esp]
		compiler.codeGenerator.op_fstp_basereg( DEF_SINGLE, REG_ESP );
	}
	else if(type==DEF_INT64||type==DEF_QWORD){
		//push edx
		compiler.codeGenerator.op_push(REG_EDX);

		//push eax
		compiler.codeGenerator.op_push(REG_EAX);
	}
	else if(type==DEF_LONG){
		//push eax
		compiler.codeGenerator.op_push(REG_EAX);
	}
	else if(type==DEF_INTEGER || (Smoothie::IsUnicode()&&type==DEF_CHAR)){
		//movsx ebx,ax
		compiler.codeGenerator.op_movsx_R32R16( REG_EBX, REG_EAX );

		//push ebx
		compiler.codeGenerator.op_push(REG_EBX);
	}
	else if(type==DEF_SBYTE || (Smoothie::IsUnicode()==false&&type==DEF_CHAR)){
		//movsx ebx,al
		compiler.codeGenerator.op_movsx_R32R8( REG_EBX, REG_EAX );

		//push ebx
		compiler.codeGenerator.op_push(REG_EBX);
	}
	else if(type==DEF_DWORD||type==DEF_WORD||type==DEF_BYTE||type==DEF_BOOLEAN||
		IsPtrType(type)){
		//push eax
		compiler.codeGenerator.op_push(REG_EAX);
	}
	else{
		SetError();
	}
}

void NewStringObject( const char *str ){
	///////////////////////////////////////////////////////
	// lpszTextStringIuWFNg𐶐A
	// IuWFNg|C^regɊi[
	///////////////////////////////////////////////////////

	char *parameter = (char *)malloc( lstrlen( str ) + 32 );
	sprintf( parameter, "%s%c%c*Char", str, 1, ESC_AS );

	Operator_New( *compiler.GetObjectModule().meta.GetClasses().GetStringClassPtr(), "", parameter, Type( DEF_OBJECT, *compiler.GetObjectModule().meta.GetClasses().GetStringClassPtr() ) );

	free( parameter );
}

void ExtendRegToBigType( int reg, int bigBasicType, int baseBasicType ){
	if( reg != REG_EAX ){
		SetError();
	}
	switch( Type::GetBasicSize( bigBasicType ) ){
		case sizeof(_int64):
			ExtendTypeTo64(baseBasicType);
			break;
		case sizeof(long):
			ExtendTypeTo32(baseBasicType,reg);
			break;
		case sizeof(short):
			ExtendTypeTo16(baseBasicType,reg);
			break;
	}
}



bool VarToReg( RELATIVE_VAR &relativeVar, const Type &baseType, Type &resultType ){
	const int useReg = REG_EAX;

	//傫Ȍ^ւ̈Öق̕ϊ
	int bigType = AutoBigCast(baseType.GetBasicType(),resultType.GetBasicType());

	if(resultType.GetBasicType()&FLAG_PTR){
		//z|C^
		resultType.SetBasicType( GetPtrType(resultType.GetBasicType()^FLAG_PTR) );

		SetVarPtrToReg(useReg, &relativeVar);
	}
	else if( resultType.IsStruct() ){
		//\̃|C^eax֊i[i\̂͒l^j
		SetVarPtrToReg(useReg, &relativeVar);
	}
	else if( resultType.IsReal() ){
		// 
		SetReg_RealVariable( resultType.GetBasicType(), &relativeVar );
	}
	else if( resultType.IsWhole() || resultType.IsObject()){
		//^
		SetReg_WholeVariable(resultType,&relativeVar,useReg);
	}
	else if( resultType.IsStruct() ){
		//\̃|C^UseReg֊i[i\̂͒l^j
		SetVarPtrToReg(useReg,&relativeVar);
	}
	else{
		return false;
	}

	if( resultType.GetBasicType() != bigType ){
		// 傫Ȍ^֕ϊꂽꍇ
		// WX^̒lLXg
		ExtendRegToBigType( useReg, bigType, resultType.GetBasicType() );

		resultType.SetBasicType( bigType );
	}

	return true;
}
bool TermMemberOpe( const Type &leftType, const Type &baseType, Type &resultType, const char *termFull, const char *termLeft, const char *member )
{
	const CClass &objClass = leftType.GetClass();

	const int useReg = REG_EAX;


	////////////////////////////////
	// CfNTigetANZTj
	////////////////////////////////
	char VarName[VN_SIZE],ArrayElements[VN_SIZE];
	GetArrayElement(member,VarName,ArrayElements);
	if(ArrayElements[0]){
		Type classType;
		if( VarName[0] == '\0' )
		{
			classType = leftType;
		}
		else
		{
			GetMemberType( leftType, VarName, classType, 0, false );
		}
		if( classType.IsObject() )
		{
			//IuWFNg|C^ecxɃRs[
			compiler.codeGenerator.op_mov_RR( REG_ECX, useReg );

			RELATIVE_VAR relativeVar;
			relativeVar.dwKind=VAR_DIRECTMEM;

			if( VarName[0] )
			{
				if( !_member_offset(
					true,	//G[\
					false,	//ǂݍݐp
					leftType,
					VarName,&relativeVar,classType,0)){
						return false;
				}

				// IuWFNgõ|C^eaxɃRs[
				if( !VarToReg( relativeVar, baseType, resultType ) ){
					SetError(11,termFull,cp);
				}


				//IuWFNg|C^X^bNɓĂ
				//push eax
				compiler.codeGenerator.op_push( REG_EAX );
			}
			else
			{
				//IuWFNg|C^X^bNɓĂ
				//push ecx
				compiler.codeGenerator.op_push( REG_ECX );
			}

			char objectFullName[VN_SIZE], dummyArrayElements[VN_SIZE];
			GetArrayElement(termFull,objectFullName,dummyArrayElements);

			CallIndexerGetterProc(/*UseReg,*/classType,objectFullName, ArrayElements,resultType, PROCFLAG_NEW );

			compiler.codeGenerator.op_pop();

			return true;
		}
	}


	///////////////////////////////////////////////////////////////////
	// o
	///////////////////////////////////////////////////////////////////
	if( GetMemberType( leftType, member, resultType, 0, false ) ){
		// oƂ

		//IuWFNg|C^ecxɃRs[
		compiler.codeGenerator.op_mov_RR( REG_ECX, useReg );

		RELATIVE_VAR relativeVar;
		relativeVar.dwKind=VAR_DIRECTMEM;

		if( !_member_offset(
			true,	//G[\
			false,	//ǂݍݐp
			leftType,
			member,&relativeVar,resultType,0)){
				return false;
		}

		if( !VarToReg( relativeVar, baseType, resultType ) ){
			SetError(11,termFull,cp);
		}

		return true;
	}


	///////////////////////////////////////////////////////////////////
	// I\bh
	///////////////////////////////////////////////////////////////////
	vector<const UserProc *> userProcs;

	char methodName[VN_SIZE], lpPtrOffset[VN_SIZE], parameter[VN_SIZE], dummy[1];
	ReferenceKind refType;
	lstrcpy( methodName, member );
	GetVarFormatString(methodName,parameter,lpPtrOffset,dummy,refType);

	objClass.EnumDynamicMethodsOrInterfaceMethods( methodName, userProcs );
	if(userProcs.size()){
		//I[o[[h
		const UserProc *pUserProc = OverloadSolutionWithStrParam(termFull,userProcs,parameter,termLeft);

		if( pUserProc )
		{
			// TODO: ̔菈͎bi[]T[`sƂ낪j
			if( pUserProc->Params().size() == 0 && parameter[0] && strstr( termFull, "[" ) )
			{
				TermMemberOpe( leftType, baseType, resultType, termFull, termLeft, methodName );

				char temporary[VN_SIZE], temp2[VN_SIZE];
				sprintf( temporary, "[%s]", parameter );
				sprintf( temp2, "%s.%s", termLeft, methodName );
				Type classType = resultType;
				return TermMemberOpe( classType, baseType, resultType, termFull, temp2, temporary );
			}

			resultType = pUserProc->ReturnType();

			{
				//IuWFNg|C^X^bNɓĂ
				//push reg
				compiler.codeGenerator.op_push( useReg );

				if( !Opcode_CallProc(parameter,pUserProc,PROCFLAG_NEW,termLeft) ){

					return false;
				}

				compiler.codeGenerator.op_pop();

				/////////////////////
				// ߂l̏
				/////////////////////

				//傫Ȍ^ւ̈Öق̕ϊ
				int bigType = AutoBigCast(baseType.GetBasicType(), resultType.GetBasicType() );

				if( resultType.GetBasicType() != bigType ){
					// 傫Ȍ^֕ϊꂽꍇ
					// WX^̒lLXg
					ExtendRegToBigType( REG_EAX, bigType, resultType.GetBasicType() );

					resultType.SetBasicType( bigType );
				}

				//SetUseRegFromRax(resultType.GetBasicType(),UseReg,XmmReg);

				// ^p[^
				ResolveFormalGenericTypeParameter( resultType, leftType, pUserProc );
			}
			
			return true;
		}
	}

	SetError();

	return false;
}
bool TermOpe( const char *term, const Type &baseType, Type &resultType, bool &isLiteral, BOOL *pbUseHeap, bool isWantObject, bool *pIsClassName, bool isProcedureCallOnly ){
	char parameter[VN_SIZE];

	// With
	char termFull[VN_SIZE];
	if(term[0]=='.'){
		GetWithName(termFull);
		lstrcat(termFull,term);
	}
	else lstrcpy(termFull,term);

	char termLeft[VN_SIZE];
	lstrcpy(termLeft,termFull);

	// p[X
	char member[VN_SIZE];
	ReferenceKind refType;
	if( SplitMemberName( termFull, termLeft, member, refType ) ){
		///////////////////////////////////////////////////////////////////
		// IuWFNgƃoɕłƂ
		// termLeft.member
		///////////////////////////////////////////////////////////////////

		isLiteral = false;

		// IuWFNǧ^擾
		bool isClassName = false;
		Type leftType;
		if( GetTermType( termLeft, Type(), leftType, isLiteral, &isClassName ) ){
			if( isClassName == false && compiler.GetObjectModule().meta.GetBlittableTypes().IsExist( leftType ) ){
				// ̃IuWFNgBlittable^̂Ƃ

				char temporary[VN_SIZE];
				lstrcpy( temporary, termLeft );
				sprintf( termLeft, "%s(%s)",
					compiler.GetObjectModule().meta.GetBlittableTypes().Find( leftType ).GetCreateStaticMethodFullName().c_str(),
					temporary );
			}
		}

		if( !TermOpe( termLeft, baseType, leftType, isLiteral, pbUseHeap, true, &isClassName ) ){
			goto globalArea;
		}

		if( isClassName ){
			// ÓIo/\bh̏ꍇ
			goto globalArea;
		}

		if( !leftType.HasMember() ){
			// oȂ^̏ꍇ
			if( isProcedureCallOnly )
			{
				SetError(1,NULL,cp);
			}
			return false;
		}

		return TermMemberOpe( leftType, baseType, resultType, termFull, termLeft, member );
	}
globalArea:


	//////////////////////////////////////////////
	// NXǂ`FbNiÓIopj
	//////////////////////////////////////////////

	if( pIsClassName ){
		if( compiler.GetObjectModule().meta.GetClasses().Find( termFull ) ){
			*pIsClassName = true;
			return true;
		}
	}


	/////////////////////////////////////////////////////////////////
	// O[oGA
	/////////////////////////////////////////////////////////////////

	const int useReg = REG_EAX;


	if(lstrcmpi(termFull,"This")==0 && isProcedureCallOnly == false ){
		//ThisIuWFNg
		resultType.SetType( DEF_OBJECT, compiler.pCompilingClass );

		SetThisPtrToReg( useReg );

		isLiteral = false;

		return true;
	}


	//////////////////////////////////////
	// ֐iDLLA[U[`Agݍ݁j
	//////////////////////////////////////
	char procName[VN_SIZE];
	char temporary[8192];

	int i2=GetCallProcName(termFull,procName);
	if(termFull[i2]=='('){
		int i4=GetStringInPare_RemovePare(parameter,termFull+i2+1);

		void *pInfo;
		int idProc=GetProc(procName,(void **)&pInfo);

		if(idProc)
		{
			if(termFull[i2+1+i4+1]!='\0')
			{
				//JbR")"ɑNULLłȂƂ
				SetError(42,NULL,cp);
			}


			{
				////////////////
				// Ăяo
				////////////////

				CallProc(idProc,pInfo,procName,parameter, baseType,resultType);


				/////////////////////
				// ߂l̏
				/////////////////////

				//傫Ȍ^ւ̈Öق̕ϊ
				int bigType = AutoBigCast(baseType.GetBasicType(), resultType.GetBasicType() );

				/*
				NumOpeŃvbV
				//X^bNփvbV
				PushReturnValue( resultType.GetBasicType() );
				*/

				if( resultType.GetBasicType() != bigType ){
					// 傫Ȍ^֕ϊꂽꍇ
					// WX^̒lLXg
					ExtendRegToBigType( useReg, bigType, resultType.GetBasicType() );

					resultType.SetBasicType( bigType );
				}

				//SetUseRegFromRax(resultType.GetBasicType(),UseReg,XmmReg);
			}


			if(resultType.IsStruct()){
				//\̂߂Ƃ̓q[v̈ɃCX^Xi[Ă
				//freeKv
				// TODO: GCɔC
				*pbUseHeap = 1;
			}

			isLiteral = false;

			return true;
		}

		ConstMacro *pConstMacro = compiler.GetObjectModule().meta.GetGlobalConstMacros().Find( procName );
		if( pConstMacro )
		{
			if( pConstMacro->GetCalcBuffer( parameter, temporary ) )
			{
				/////////////////////////
				// }N֐
				/////////////////////////

				//JbR")"ɑNULLłȂƂ̓G[ɂ
				if(termFull[i2+1+i4+1]!='\0') SetError(42,NULL,cp);

				//}N֐̏ꍇ
				NumOpe(useReg, temporary,Type(),resultType);

				if(!IS_LITERAL(resultType.GetIndex())){
					//elł͂ȂƂ
					isLiteral = false;
				}

				return true;
			}
		}
	}
	else if( isProcedureCallOnly ){
		// ֐ĂяoȊO͎󂯕tȂ
		return false;
	}


	////////////////////////////////
	// CfNTigetANZTj
	////////////////////////////////

	char VarName[VN_SIZE],ArrayElements[VN_SIZE];
	GetArrayElement(termFull,VarName,ArrayElements);
	if(ArrayElements[0]){
		Type classType;
		GetVarType(VarName,classType,false);
		if( classType.IsObject() )
		{
			CallIndexerGetterProc(/*UseReg,*/classType,VarName, ArrayElements,resultType);

			isLiteral = false;

			return true;
		}
	}


	////////////////////////////////
	// ϐ
	////////////////////////////////

	RELATIVE_VAR relativeVar;
	if(GetVarOffset(
		false,	//G[\Ȃ
		false,	//ǂݍݐp
		termFull,
		&relativeVar,resultType)){
		//////////
		// ϐ
		//////////

		if( !VarToReg( relativeVar, baseType, resultType ) ){
			SetError(11,termFull,cp);
		}

		isLiteral = false;

		return true;
	}


	/////////////////////////////////
	// vpeBp̃\bh
	/////////////////////////////////

	//zvfr
	GetArrayElement(termFull,VarName,ArrayElements);

	if(GetSubHash(VarName,0)){

		{
			CallPropertyMethod(termFull,NULL,resultType);

			//傫Ȍ^ւ̈Öق̕ϊ
			int bigType = AutoBigCast(baseType.GetBasicType(), resultType.GetBasicType() );

			if( resultType.GetBasicType() != bigType ){
				// 傫Ȍ^֕ϊꂽꍇ
				// WX^̒lLXg
				ExtendRegToBigType( REG_EAX, bigType, resultType.GetBasicType() );

				resultType.SetBasicType( bigType );
			}

			//SetUseRegFromRax(resultType.GetBasicType(),UseReg,XmmReg);
		}


		if(resultType.IsStruct()){
			//\̂߂Ƃ̓q[v̈ɃCX^Xi[Ă
			//freeKv
			// TODO: GCɔC
			*pbUseHeap = 1;
		}

		isLiteral = false;

		return true;
	}

	if( isProcedureCallOnly )
	{
		SetError(3, termLeft, cp );
	}

	return false;
}


bool NumOpe( int reg,
			const char *expression,
			const Type &baseType,
			Type &resultType,
			BOOL *pbUseHeap ){

	if( !NumOpe( expression, baseType, resultType, pbUseHeap ) ){
		return false;
	}

	if( reg != REG_EAX ){
		// TODO: 
		SetError();
	}

	if( resultType.IsReal() ){
		//fld ptr[esp]
		compiler.codeGenerator.op_fld_ptr_esp( resultType.GetBasicType() );

		//add esp,size
		compiler.codeGenerator.op_add_esp( resultType.GetBasicSize() );
	}
	else{
		//pop eax
		compiler.codeGenerator.op_pop(REG_EAX);

		if( resultType.Is64() ){
			//pop edx
			compiler.codeGenerator.op_pop(REG_EDX);
		}
	}
	return true;
}
bool NumOpe( const char *expression,
			const Type &baseType,
			Type &resultType,
			BOOL *pbUseHeap )
{
	int i,i2,i3;
	char temporary[1024],temp2[1024];

	if(expression[0]=='\0'){
		SetError(1,NULL,cp);
		return false;
	}

	if( !baseType.IsNull() && expression[0] == '[' ){
		// ez̏ꍇ

		int dataTableOffset;
		if( !compiler.GetObjectModule().dataTable.MakeLiteralArrayBuffer( expression, baseType, dataTableOffset ) )
		{
			return false;
		}

		//mov eax,i2
		compiler.codeGenerator.op_mov_RV(REG_EAX,dataTableOffset, Schedule::DataTable );

		resultType = baseType;

		//push eax
		compiler.codeGenerator.op_push( REG_EAX );

		return true;
	}

	bool isLiteralCalculation;
	if( NumOpe_GetType( expression, baseType, resultType, &isLiteralCalculation ) )
	{
		if( isLiteralCalculation )
		{
			//EӒll̒萔̏ꍇ
			_int64 i64data;
			StaticCalculation(true, expression,baseType.GetBasicType(),&i64data,resultType);

			if( resultType.GetBasicSize() == sizeof(_int64) ){
				//64rbgiL萮/j

				//push HILONG(i64data)
				compiler.codeGenerator.op_push_V((long)*(long *)(((char *)(&i64data))+4));

				//push LOLONG(i64data)
				compiler.codeGenerator.op_push_V(*(long *)(&i64data));
			}
			else if( resultType.IsSingle() ){
				//single

				double dbl;
				memcpy(&dbl,&i64data,sizeof(_int64));

				float flt;
				flt=(float)dbl;
				long l;
				memcpy(&l,&flt,sizeof(long));

				//push flt
				compiler.codeGenerator.op_push_V(l);
			}
			else{
				//iL/j

				long l = (long)i64data;

				if(resultType.GetBasicSize()==sizeof(char)) l = l & 0x000000FF;
				if(resultType.GetBasicSize()==sizeof(short)) l = l & 0x0000FFFF;

				//push term
				compiler.codeGenerator.op_push_V(l);
			}
			return true;
		}
	}

	if(expression[0]==1 )
	{
		if( expression[1]==ESC_NEW ){
			//NewZqiIuWFNgj

			if( !Operator_New( expression+2, baseType, resultType ) ){
				return false;
			}

			return true;
		}
		else if( expression[1] == ESC_SYSTEM_STATIC_NEW )
		{
			// ÓÏɃIuWFNg

			// ÓÏɃIuWFNg𐶐
			int dataTableOffset;
			if( !compiler.GetObjectModule().dataTable.MakeConstObjectToProcessStaticBuffer( expression + 2, resultType, dataTableOffset ) )
			{
				return false;
			}

			// push value
			compiler.codeGenerator.op_push_V( dataTableOffset, Schedule::DataTable );

			return true;
		}
	}


	/////////////////////////////////
	// vft|[hŎ擾
	/////////////////////////////////

	char *values[255];
	long calc[255];
	long stack[255];
	int pnum;
	if(!GetNumOpeElements(expression,&pnum,values,calc,stack)){
		for(i=0;i<pnum;i++){
			if(values[i]) HeapDefaultFree(values[i]);
		}
		return false;
	}


	BOOL bError;
	bError=0;

	//el݂̂̌vZǂ𔻕ʂ邽߂̃tO
	BOOL bLiteralCalculation=1;

	double dbl;
	int sp;
	int type_stack[255];
	bool isNothing_stack[255];
	LONG_PTR index_stack[255];
	BOOL bUseHeap[255];
	_int64 i64data;
	for(i=0,sp=0;i<pnum;i++){
		int idCalc;
		idCalc=calc[i]%100;

		if(idCalc){
			if(type_stack[sp-2]==DEF_OBJECT){
				if( idCalc == CALC_AS
					&& type_stack[sp-1] == ( DEF_OBJECT | FLAG_CAST )
					&& index_stack[sp-1] == index_stack[sp-2]
					|| isNothing_stack[sp-2] ){
						// ̌^A܂Nothingɑ΂AsAsZqĂяoȂ
				}
				else if( idCalc == CALC_AS
					&& type_stack[sp-1] == ( DEF_OBJECT | FLAG_CAST )
					&& ( ((CClass *)index_stack[sp-1])->IsEqualsOrSubClass( (CClass *)index_stack[sp-2] ) || ((CClass *)index_stack[sp-2])->IsEqualsOrSubClass( (CClass *)index_stack[sp-1] )
					)){
						// _ELXg
				}
				else{
					//I[o[[hꂽIy[^Ăяo
					i2=CallOperatorProc(idCalc,baseType,type_stack,index_stack,bUseHeap,sp);
					if(i2==0){
						if(idCalc==CALC_EQUAL) lstrcpy(temp2,"==");
						else GetCalcName(idCalc,temp2);
						sprintf(temporary,"Operator %s",temp2);
						SetError(27,temporary,cp);
						goto error;
					}
					else if(i2==-1) goto error;

					continue;
				}
			}

			if(!CheckCalcType(idCalc,type_stack,sp)) goto error;
		}

		switch(idCalc){
			//l
			case 0:
				index_stack[sp]=-1;
				isNothing_stack[sp] = false;
				bUseHeap[sp]=0;

				char *term;
				term=values[i];

				if( calc[i+1]%100 == CALC_AS ){
					// AsZq̉EӒl
					//^
					if( compiler.StringToType( term, resultType ) ){
						resultType.SetBasicType( resultType.GetBasicType() | FLAG_CAST );
					}
					else{
						SetError(3, term, cp );
						goto error;
					}

					type_stack[sp] = resultType.GetBasicType();
					index_stack[sp] = resultType.GetIndex();
					sp++;

					break;
				}

				if( (term[0]=='e'||term[0]=='E')
					&& (term[1]=='x'||term[1]=='X')
					&& term[2]=='\"'
					|| term[0] == '\"' )
				{
					bool isEx = true;
					if( term[0] == '\"' )
					{
						isEx = false;
					}

					if( isEx )
					{
						// gŃeiGXP[vV[PX\j
						if(!RemoveStringQuotes(term+2)){
							SetError(43,NULL,cp);
							goto error;
						}
						i3=FormatString_EscapeSequence(term+2);
						term+=2;
					}
					else
					{
						// ʏ핶
						if(!RemoveStringQuotes(term)){
							SetError(43,NULL,cp);
							goto error;
						}
						i3=lstrlen(term);
					}

					if( !baseType.IsPointer() )
					{
						//v^CvIuWFNgA܂͖̂Ƃ

						//String^IuWFNg𐶐
						i2 = compiler.GetObjectModule().dataTable.MakeConstStringObjectToProcessStaticBuffer( term );
						
						// push value
						compiler.codeGenerator.op_push_V( i2, Schedule::DataTable );

						type_stack[sp]=DEF_OBJECT;
						index_stack[sp]=(LONG_PTR)compiler.GetObjectModule().meta.GetClasses().GetStringClassPtr();
						bLiteralCalculation=0;

						sp++;
						break;
					}
StrLiteral:
					type_stack[sp]=typeOfPtrChar;
					bLiteralCalculation=0;

					i2=compiler.GetObjectModule().dataTable.AddString(term,i3);

					//push DataSize
					compiler.codeGenerator.op_push_V( i2, Schedule::DataTable );
				}
				else if(IsVariableTopChar(term[0])||
					term[0]=='*'||
					(term[0]=='.'&&IsVariableTopChar(term[1]))){
					//////////////////
					// 炩̎ʎq

					bool isLiteral;
					if( TermOpe( term, baseType, resultType, isLiteral, &bUseHeap[sp] ) ){
						if(resultType.IsNull()){
							//߂l݂ȂƂ
							for(i2=0;;i2++){
								if(term[i2]=='('||term[i2]=='\0'){
									term[i2]=0;
									break;
								}
							}
							SetError(38,term,cp);

							goto error;
						}

						type_stack[sp] = resultType.GetBasicType();
						index_stack[sp] = resultType.GetIndex();

						if( !isLiteral ){
							bLiteralCalculation=0;
						}

						if( resultType.GetBasicType() & FLAG_CAST ){
							// ^̂
							SetError();
						}
						else{
							if( resultType.IsReal() ){
								//sub esp,size
								//fstp ptr[esp]
								compiler.codeGenerator.op_fstp_push( resultType );
							}
							else{
								if( resultType.Is64() ){
									//push edx
									compiler.codeGenerator.op_push( REG_EDX );
								}
								else{
									ExtendTypeTo32( resultType.GetBasicType(), REG_EAX );
								}

								//push eax
								compiler.codeGenerator.op_push( REG_EAX );
							}
						}

						sp++;
						break;
					}


					// Nothing
					if( lstrcmp( term, "Nothing" ) == 0 ){
						isNothing_stack[sp] = true;

						type_stack[sp] = DEF_OBJECT;
						if( baseType.IsObject() ){
							index_stack[sp] = baseType.GetIndex();
						}
						else{
							index_stack[sp] = (LONG_PTR)compiler.GetObjectModule().meta.GetClasses().GetObjectClassPtr();
						}

						bLiteralCalculation = 0;

						//push 0
						compiler.codeGenerator.op_push_V( 0 );

						sp++;
						break;
					}


					//////////////
					// 萔̏ꍇ
					//////////////

					i3 = compiler.GetObjectModule().meta.GetGlobalConsts().GetBasicType(term);
					if(i3){
						if( compiler.GetObjectModule().meta.GetGlobalConsts().IsStringPtr( term ) ){
							//e

							if( baseType.IsObject() || baseType.IsNull() )
							{
								//v^CvIuWFNgA܂͖̂Ƃ

								//String^IuWFNg𐶐
								NewStringObject(term);

								type_stack[sp]=DEF_OBJECT;
								index_stack[sp]=(LONG_PTR)compiler.GetObjectModule().meta.GetClasses().GetStringClassPtr();
								bLiteralCalculation=0;

								sp++;
								break;
							}

							double dbl = compiler.GetObjectModule().meta.GetGlobalConsts().GetDoubleData(term);
							memcpy(&i64data,&dbl,sizeof(double));

							//oCg
							i3=lstrlen((char *)i64data);

							memcpy(term,(char *)i64data,i3);
							term[i3]=0;
							goto StrLiteral;
						}

						type_stack[sp]=i3;
						if(IsRealNumberType(i3)){
							//
							double dbl = compiler.GetObjectModule().meta.GetGlobalConsts().GetDoubleData(term);
							memcpy(&i64data,&dbl,sizeof(double));
							goto Literal;
						}
						else if(IsWholeNumberType(i3)){
							//
							i64data = compiler.GetObjectModule().meta.GetGlobalConsts().GetWholeData(term);
							goto Literal;
						}
						else{
							SetError(300,NULL,cp);
							goto error;
						}
					}


					//Y鎯ʎqȂƂ̓G[ɂ
					bError=1;
					SetError(3,term,cp);
					type_stack[sp]=DEF_DOUBLE;
				}
				else{
					//el
					type_stack[sp]=GetLiteralValue(term,&i64data,baseType.GetBasicType());
Literal:
					if(type_stack[sp]==DEF_INT64||
						type_stack[sp]==DEF_QWORD||
						type_stack[sp]==DEF_DOUBLE){
						//64rbgiL萮/j

						//push HILONG(dbl)
						compiler.codeGenerator.op_push_V((long)*(long *)(((char *)(&i64data))+4));

						//push LOLONG(dbl)
						compiler.codeGenerator.op_push_V(*(long *)(&i64data));
					}
					else if(type_stack[sp]==DEF_SINGLE){
						//single

						float flt;
						memcpy(&dbl,&i64data,sizeof(double));
						flt=(float)dbl;
						memcpy(&i3,&flt,sizeof(long));

						//push term
						compiler.codeGenerator.op_push_V(i3);
					}
					else{
						//̑

						//push term
						compiler.codeGenerator.op_push_V((long)i64data);

						if((long)i64data==0) index_stack[sp]=LITERAL_NULL;
					}


					//el̎
					if(Is64Type(type_stack[sp])==0&&IsRealNumberType(type_stack[sp])==0){
						//iL/j

						index_stack[sp]=GetLiteralIndex(i64data);
					}
				}
				sp++;
				break;

			//_Zq
			case CALC_XOR:
				//value[sp-2] xor= value[sp-1]
				//xorZ
				if(!Calc_Xor(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_OR:
				//value[sp-2] or= value[sp-1]
				//orZ
				if(!Calc_Or(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_AND:
				//value[sp-2] and= value[sp-1]
				//andZ
				if(!Calc_And(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_NOT:
				//value[sp-1]=Not value[sp-1]
				//NOTZq
				if(!Calc_Not(type_stack,sp)) goto error;
				break;

			//rZq
			case CALC_PE:
				//value[sp-2]<=value[sp-1]
				if(!Calc_Relation_PE(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_QE:
				//value[sp-2]>=value[sp-1]
				if(!Calc_Relation_QE(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_P:
				//value[sp-2]<value[sp-1]
				if(!Calc_Relation_P(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_Q:
				//value[sp-2]>value[sp-1]
				if(!Calc_Relation_Q(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_NOTEQUAL:
				//value[sp-2]<>value[sp-1]
				if(!Calc_Relation_NotEqual(type_stack,&sp)) goto error;
				break;
			case CALC_EQUAL:
				//value[sp-2]=value[sp-1]
				if(!Calc_Relation_Equal(type_stack,&sp)) goto error;
				break;

			//rbgVtg
			case CALC_SHL:
				//value[sp-2]=value[sp-2]<<value[sp-1]
				if(!Calc_SHL(type_stack,&sp)) goto error;
				break;
			case CALC_SHR:
				//value[sp-2]=value[sp-2]>>value[sp-1]
				if(!Calc_SHR(type_stack,&sp)) goto error;
				break;

			//ZpZ
			case CALC_ADDITION:
			case CALC_SUBTRACTION:
			case CALC_PRODUCT:
				if(!CalcTwoTerm_Arithmetic(idCalc,type_stack,index_stack,&sp)) goto error;
				break;

			case CALC_MOD:
				//value[sp-2]%=value[sp-1]
				//]Z
				if(!Calc_Mod(type_stack,&sp)) goto error;
				break;
			case CALC_QUOTIENT:
				//value[sp-2]/=value[sp-1];
				//Z
				if(!Calc_Divide(type_stack,&sp,baseType.GetBasicType())) goto error;
				break;
			case CALC_INTQUOTIENT:
				//value[sp-2]/=value[sp-1]
				//Z
				if(!Calc_IntDivide(type_stack,index_stack,&sp)) goto error;
				break;
			case CALC_MINUSMARK:
				//value[sp-1]=-value[sp-1]
				//]
				if(!Calc_MinusMark(type_stack,sp)) goto error;
				index_stack[sp-1]=-1;
				break;
			case CALC_POWER:
				//ׂ扉Zi_Ẑ݁j
				if(!Calc_Power(type_stack,&sp)) goto error;
				break;
			case CALC_AS:
				//LXg
				if(!Calc_Cast(type_stack,index_stack,&sp)) goto error;
				break;

			case CALC_BYVAL:
				//|C^^Qƌ^
				if( PTR_LEVEL( type_stack[sp-1] ) <= 0 ){
					//|C^^ł͂ȂƂ
					SetError( 3, NULL, cp );
					goto error;
				}

				type_stack[sp-1] = PTR_LEVEL_DOWN( type_stack[sp-1] );

				break;

			default:
				SetError(300,NULL,cp);
				goto error;
		}
	}

	if(bError) goto error;

	if(sp!=1){
		SetError(1,NULL,cp);
		goto error;
	}

	if(bLiteralCalculation){
		//EӒll̒萔̏ꍇ
		SetError();
	}
	else{
		//EӒll̒萔ł͂ȂƂ
		if(IS_LITERAL(index_stack[0])) index_stack[0]=-1;
	}

	if(pbUseHeap) *pbUseHeap=bUseHeap[0];

	resultType.SetType( type_stack[0], index_stack[0] );

	bool isSuccessful = true;
	goto finish;


error:
	isSuccessful = false;
	goto finish;


finish:

	for(i=0;i<pnum;i++){
		if(values[i]) HeapDefaultFree(values[i]);
	}

	// Ih߂̃_~[isj
	if( lstrcmp( expression, "-1/t" ) == 0 )
	{
	}

	return isSuccessful;
}
